package moe.hazu.tinkeringabnormally.data.sprite;

import moe.hazu.tinkeringabnormally.data.material.MaterialIds;
import slimeknights.tconstruct.library.client.data.material.AbstractMaterialSpriteProvider;
import slimeknights.tconstruct.library.client.data.spritetransformer.GreyToColorMapping;
import slimeknights.tconstruct.library.materials.definition.MaterialVariantId;

import static slimeknights.tconstruct.tools.data.sprite.TinkerPartSpriteProvider.WOOD;

public class TinkerMaterialSpriteProvider extends AbstractMaterialSpriteProvider {

    @Override
    public String getName() {
        return "Tinkers' Construct Materials";
    }

    @Override
    protected void addAllMaterials() {
        buildPlanks(MaterialIds.willow).colorMapper(GreyToColorMapping.builderFromBlack().addARGB(63, 0xFF323926).addARGB(102, 0xFF3C472B).addARGB(140, 0xFF4D593A).addARGB(178, 0xFF59633F).addARGB(216, 0xFF586645).addARGB(234, 0xFF657751).addARGB(255, 0xFF698450).build());
        buildPlanks(MaterialIds.pine).colorMapper(GreyToColorMapping.builderFromBlack().addARGB(63, 0xFF6A5041).addARGB(102, 0xFF755646).addARGB(140, 0xFF7F5D4B).addARGB(178, 0xFF8E7253).addARGB(216, 0xFF9A7C5E).addARGB(234, 0xFFB4956C).addARGB(255,0xFFC6A175).build());
        buildPlanks(MaterialIds.cherry).colorMapper(GreyToColorMapping.builderFromBlack().addARGB(63, 0xFF2C1411).addARGB(102, 0xFF351713).addARGB(140, 0xFF3D1A16).addARGB(178, 0xFF421D17).addARGB(216, 0xFF4F221B).addARGB(234, 0xFF602822).addARGB(255, 0xFF6B2C26).build());
        buildPlanks(MaterialIds.wisteria).colorMapper(GreyToColorMapping.builderFromBlack().addARGB(63, 0xFF806850).addARGB(102, 0xFF957863).addARGB(140, 0xFF9C816D).addARGB(178, 0xFFAC9872).addARGB(216, 0xFFB8A784).addARGB(234, 0xFFD9D1B6).addARGB(255, 0xFFE0DCBD).build());
        buildPlanks(MaterialIds.driftwood).colorMapper(GreyToColorMapping.builderFromBlack().addARGB(63, 0xFF272825).addARGB(102, 0xFF30302C).addARGB(140, 0xFF393A34).addARGB(178, 0xFF4A463C).addARGB(216, 0xFF555048).addARGB(234, 0xFF676057).addARGB(255, 0xFF756D60).build());
        buildPlanks(MaterialIds.river).colorMapper(GreyToColorMapping.builderFromBlack().addARGB(63, 0xFF3E3423).addARGB(102, 0xFF423221).addARGB(140, 0xFF443327).addARGB(178, 0xFF543d24).addARGB(216, 0xFF5E4832).addARGB(234, 0xFF6D5446).addARGB(255, 0xFF7F5E4B).build());
        buildPlanks(MaterialIds.azalea).colorMapper(GreyToColorMapping.builderFromBlack().addARGB(63, 0xFF1A1D2C).addARGB(102, 0xFF16202C).addARGB(140, 0xFF1E2338).addARGB(178, 0xFF1F2E3A).addARGB(216, 0xFF273538).addARGB(234, 0xFF374051).addARGB(255, 0xFF41476B).build());
    }

    private MaterialSpriteInfoBuilder buildPlanks(MaterialVariantId material) {
        return buildMaterial(material)
                .meleeHarvest().ranged().shieldCore().statType(WOOD)
                .fallbacks("wood", "stick", "primitive");
    }
}
